package com.seeyon.apps.thirdparyServlet;

import com.seeyon.ctp.common.AppContext;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.common.util.XmlUtil;
import com.seeyon.ctp.organization.bo.*;
import com.seeyon.ctp.organization.manager.OrgManager;
import com.seeyon.ctp.organization.manager.OrgManagerDirect;
import com.seeyon.ctp.rest.util.MemberUtil;
import com.seeyon.ctp.util.Datetimes;
import com.seeyon.ctp.util.FlipInfo;
import com.seeyon.v3x.services.organization.AccountManager;
import com.seeyon.v3x.services.organization.DepartmentManager;
import org.apache.commons.collections.ListUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.util.StringUtils;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.ParseException;
import java.util.*;


public class ThirdparyServlet extends HttpServlet {
    private static final Log log = LogFactory.getLog(ThirdparyServlet.class);
    private OrgManager orgManager = (OrgManager) AppContext.getBean("orgManager");
    private AccountManager accountManager = (AccountManager) AppContext.getBean("V3xAccountManager");
    private DepartmentManager departmentManager = (DepartmentManager) AppContext.getBean("V3xDepartmentManager");
    private OrgManagerDirect orgManagerDirect = (OrgManagerDirect)AppContext.getBean("orgManagerDirect");

    /**
     * @see HttpServlet#HttpServlet()
     */
    public ThirdparyServlet() {
        super();
        // TODO Auto-generated constructor stub
    }
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		//response.getWriter().append("Served at: ").append(request.getContextPath());
		try {
			linktofutaisystem(request,response);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void linktofutaisystem(HttpServletRequest request, HttpServletResponse response) {
        try{
            Map<String, String[]> parameterMap = request.getParameterMap();
            String syncXml = parameterMap.get("syncXml")[0];
            System.out.println(syncXml);
            Map<String,Object> returnMap = new HashMap<>();
            Map<String,Object> map = XmlUtil.xml2map(syncXml);
            System.out.println(map.get("dataType"));
            if (map.get("dataType").equals("1")){  //组织机构
                Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
                Map<String,Object> oldContent = (Map<String, Object>) syncContent.get("oldContent");
                Map<String,Object> baseInfo = (Map<String, Object>) oldContent.get("baseInfo");
                String isCorp = (String) baseInfo.get("isCorp");
                if (isCorp.equals("1")){    //公司
                    if (map.get("operType").equals("1")){   //新增
                        this.addAccount(map,returnMap);
                    }else if (map.get("operType").equals("2")){   //删除
                        this.deleteAccount(map,returnMap);
                    }else if (map.get("operType").equals("4") || map.get("operType").equals("8")){   //更新
                        this.updateAccount(map,returnMap);
                    }else{
                        returnMap.put("status",2);
                        returnMap.put("errcode","error");
                        returnMap.put("errormsg","对应操作类型为其他类型");
                    }
                }else if (isCorp.equals("0")){   //部门
                    if (map.get("operType").equals("1")){   //新增
                        this.addDept(map,returnMap);
                    }else if (map.get("operType").equals("2")){   //删除
                        this.deleteDept(map,returnMap);
                    }else if (map.get("operType").equals("4") || map.get("operType").equals("8")){   //更新
                        this.updateDept(map,returnMap);
                    }else{
                        returnMap.put("status",2);
                        returnMap.put("errcode","error");
                        returnMap.put("errormsg","对应操作类型为其他类型");
                    }
                }else {
                    returnMap.put("status",2);
                    returnMap.put("errcode","error");
                    returnMap.put("errormsg","组织机构类型为其他类型");
                }
            } else if (map.get("dataType").equals("2")){  //用户
                if (map.get("operType").equals("1")){   //新增
                    this.addMember(map,returnMap);
                }else if (map.get("operType").equals("2")){   //删除
                    this.deleteMember(map,returnMap);
                }else if (map.get("operType").equals("4") || map.get("operType").equals("8")){   //更新
                    this.updateMember(map,returnMap);
                }else{
                    returnMap.put("status",2);
                    returnMap.put("errcode","error");
                    returnMap.put("errormsg","对应操作类型为其他类型");
                }
            } else {
                returnMap.put("status",2);
                returnMap.put("errcode","error");
                returnMap.put("errormsg","数据类型为其他类型");
            }
            String returnData = XmlUtil.recursionMapToXml(returnMap);
            System.out.println(returnData);
            ServletOutputStream out=response.getOutputStream();
            OutputStreamWriter ow=new OutputStreamWriter(out,"utf-8");
            ow.write(returnData);
            ow.flush();
            ow.close();
        }catch (Exception e){
            e.printStackTrace();
        }
	}

    /**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		// TODO Auto-generated method stub
		doGet(request, response);
	}

	public static String sendPost(String url,String param){
        OutputStreamWriter out =null;
        BufferedReader reader = null;
        String response = "";

        //创建连接
        try {
            URL httpUrl = null; //HTTP URL类 用这个类来创建连接
            //创建URL
            httpUrl = new URL(url);
            //建立连接
            HttpURLConnection conn = (HttpURLConnection) httpUrl.openConnection();
            conn.setRequestMethod("POST");
            conn.setRequestProperty("Content-Type", "application/json");
            conn.setRequestProperty("connection", "keep-alive");
            conn.setUseCaches(false);//设置不要缓存
            conn.setInstanceFollowRedirects(true);
            conn.setDoOutput(true);
            conn.setDoInput(true);
            conn.connect();
            //POST请求
            out = new OutputStreamWriter(
                    conn.getOutputStream());
            out.write(param);
            out.flush();
            //读取响应
            reader = new BufferedReader(new InputStreamReader(
                    conn.getInputStream()));
            String lines;
            while ((lines = reader.readLine()) != null) {
                lines = new String(lines.getBytes(), "utf-8");
                response+=lines;
            }
            reader.close();
            // 断开连接
            conn.disconnect();

        } catch (Exception e) {
            System.out.println("发送 POST 请求出现异常！"+e);
            e.printStackTrace();
        }
        //使用finally块来关闭输出流、输入流
        finally{
            try{
                if(out!=null){
                    out.close();
                }
                if(reader!=null){
                    reader.close();
                }
            }
            catch(IOException ex){
                ex.printStackTrace();
            }
        }

        return response;
    }


  public static String sendPost2(String url, String data) {
      String response = null;

      try {
          CloseableHttpClient httpclient = null;
          CloseableHttpResponse httpresponse = null;
          try {
              httpclient = HttpClients.createDefault();
              HttpPost httppost = new HttpPost(url);
              StringEntity stringentity = new StringEntity(data,
                      ContentType.create("application/json", "UTF-8"));
              httppost.setEntity(stringentity);
              httpresponse = httpclient.execute(httppost);
              response = EntityUtils
                      .toString(httpresponse.getEntity());

          } finally {
              if (httpclient != null) {
                  httpclient.close();
              }
              if (httpresponse != null) {
                  httpresponse.close();
              }
          }
      } catch (Exception e) {
          e.printStackTrace();
      }
      return response;
  }

    private void addAccount(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> parentInfo = (Map<String, Object>) newContent.get("parentInfo");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        Long accId = accountManager.getAccountIdByCode((String) baseInfo.get("deptUniCode"));
        V3xOrgAccount account = orgManager.getAccountById(accId);
        if (account != null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_1_0001");
            returnMap.put("errormsg","组织已存在");
            return;
        }
        if (StringUtils.isEmpty(baseInfo.get("deptName"))|| StringUtils.isEmpty(baseInfo.get("deptUniCode"))
                || StringUtils.isEmpty(baseInfo.get("showNum"))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_1_0003");
            returnMap.put("errormsg","必填属性未填");
            return;
        }
        V3xOrgAccount unit = new V3xOrgAccount();
        unit.setIdIfNew();
        unit.setOrgAccountId(unit.getId());
        unit.setCode((String) baseInfo.get("deptUniCode"));
        unit.setName((String) baseInfo.get("deptName"));
        unit.setSortId(Long.parseLong((String) baseInfo.get("showNum")));
        if (StringUtils.isEmpty(((String) parentInfo.get("parentCode"))) ||
                (((String)parentInfo.get("parentCode")).equals((String)baseInfo.get("deptUniCode")))){
            Long accountId = accountManager.getAccountIdByCode("org-admin");
            if (StringUtils.isEmpty(accountId)||accountId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_1_1_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            unit.setSuperior(accountId);
        }else {
            String code = (String) parentInfo.get("parentCode");
            Long accountId = accountManager.getAccountIdByCode(code);
            if (StringUtils.isEmpty(accountId)||accountId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_1_1_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            unit.setSuperior(accountId);
        }
        Map admininfo = new HashMap();
        admininfo.put("loginName", (String)baseInfo.get("deptUniCode")+"gly");//管理员登录名
        admininfo.put("password", "123456");//管理员密码
        V3xOrgMember adminmember = MemberUtil.createMember(admininfo);
        OrganizationMessage result = new OrganizationMessage();
        result = orgManagerDirect.addAccount(unit,adminmember);
        System.out.println(result.isSuccess());
        if (!result.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_1_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }
    private void deleteAccount(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        Long accountId = accountManager.getAccountIdByCode((String) baseInfo.get("deptUniCode"));
        V3xOrgAccount account = orgManager.getAccountById(accountId);
        if (account == null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_0002");
            returnMap.put("errormsg","组织不存在");
            return;
        }
        List<V3xOrgMember> members = orgManagerDirect.getAllMembers(accountId, false);
        List<V3xOrgDepartment> depts = orgManagerDirect.getAllDepartments(accountId, true, (Boolean)null, (String)null, (Object)null, (FlipInfo)null);
        List<V3xOrgPost> posts = orgManagerDirect.getAllPosts(accountId, false);
        List<V3xOrgTeam> teams = orgManagerDirect.getAllTeams(accountId, false);
        List<V3xOrgAccount> accounts = orgManager.getChildAccount(accountId, false);
        if (!((depts == null || depts.size() <= 0) && (posts == null || posts.size() <= 0) && (teams == null || teams.size() <= 0) && (accounts == null || accounts.size() <= 0))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_0005");
            returnMap.put("errormsg","存在子组织");
            return;
        }
        if (!(members == null || members.size() <= 0)){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_0006");
            returnMap.put("errormsg","组织下存在用户");
            return;
        }
        OrganizationMessage result = new OrganizationMessage();
        if (!account.getIsDeleted())
            result = orgManagerDirect.deleteAccount(account);
        else {
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_9999");
            returnMap.put("errormsg","其它错误");
        }
        if (!result.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }
    private void updateAccount(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> oldContent = (Map<String, Object>) syncContent.get("oldContent");
        Map<String,Object> baseInfoOld = (Map<String, Object>) oldContent.get("baseInfo");
        Map<String,Object> parentInfo = (Map<String, Object>) newContent.get("parentInfo");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        if (StringUtils.isEmpty(baseInfo.get("deptName"))|| StringUtils.isEmpty(baseInfo.get("deptUniCode"))
                || StringUtils.isEmpty(baseInfo.get("showNum"))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_4_0003");
            returnMap.put("errormsg","必填属性未填");
            return;
        }
        Long accId = accountManager.getAccountIdByCode((String) baseInfo.get("deptUniCode"));
        V3xOrgAccount account = orgManager.getAccountById(accId);
//        V3xOrgAccount account = orgManager.getAccountByName((String) baseInfoOld.get("deptName"));
        if (account == null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_4_0002");
            returnMap.put("errormsg","组织不存在");
            return;
        }
        if (StringUtils.isEmpty(((String) parentInfo.get("parentCode"))) ||
                (((String)parentInfo.get("parentCode")).equals((String)baseInfo.get("deptUniCode")))){
            Long accountId = accountManager.getAccountIdByCode("org-admin");
            if (StringUtils.isEmpty(accountId)||accountId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_1_4_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            account.setSuperior(accountId);
        }else {
            String code = (String) parentInfo.get("parentCode");
            Long accountId = accountManager.getAccountIdByCode(code);
            if (StringUtils.isEmpty(accountId)||accountId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_1_4_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            account.setSuperior(accountId);
        }
        account.setName((String) baseInfo.get("deptName"));
        account.setSortId(Long.parseLong((String) baseInfo.get("showNum")));
        OrganizationMessage result = new OrganizationMessage();
        result = orgManagerDirect.updateAccount(account);
        System.out.println(result.isSuccess());
        if (!result.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_4_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }

    private void addDept(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> parentInfo = (Map<String, Object>) newContent.get("parentInfo");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        if (StringUtils.isEmpty(baseInfo.get("deptName"))|| StringUtils.isEmpty(baseInfo.get("deptUniCode"))
                || StringUtils.isEmpty(baseInfo.get("showNum"))||StringUtils.isEmpty(parentInfo.get("parentCode"))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_1_0003");
            returnMap.put("errormsg","必填属性未填");
            return;
        }
        List<V3xOrgDepartment> departments = orgManagerDirect.getAllDepartments(null,null,true,null,null,null);
        Long accId = -1L;
        for (V3xOrgDepartment department : departments) {
            if (department.getCode().equals((String) baseInfo.get("deptUniCode"))) {
                accId = department.getId();
                break;
            }
        }
//        Long accId = departmentManager.getDepartmentIdByCode((String) baseInfo.get("deptUniCode"));
        V3xOrgDepartment orgDepartment = orgManager.getDepartmentById(accId);
//        V3xOrgAccount account = orgManager.getAccountByName((String) baseInfo.get("deptName"));
        if (orgDepartment != null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_1_0001");
            returnMap.put("errormsg","组织已存在");
            return;
        }
        V3xOrgDepartment department = new V3xOrgDepartment();
        department.setIdIfNew();
        department.setName((String) baseInfo.get("deptName"));
        department.setCode((String) baseInfo.get("deptUniCode"));
        if (parentInfo.get("isCorp").equals("0")){
            Long departmentId = -1L;
            for (V3xOrgDepartment department1 : departments) {
                if (department1.getCode().equals((String) parentInfo.get("parentCode"))) {
                    departmentId = department1.getId();
                    break;
                }
            }
//            Long departmentId = departmentManager.getDepartmentIdByCode((String) parentInfo.get("parentCode"));
            if (StringUtils.isEmpty(departmentId)||departmentId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_2_1_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            department.setSuperior(departmentId);
            V3xOrgUnit unit = orgManager.getUnitById(departmentId);
            department.setOrgAccountId(unit.getOrgAccountId());
        } else if (parentInfo.get("isCorp").equals("1")){
            Long accountId = accountManager.getAccountIdByCode((String) parentInfo.get("parentCode"));
            if (StringUtils.isEmpty(accountId)||accountId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_2_1_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            department.setSuperior(accountId);
            department.setOrgAccountId(accountId);
        }
        department.setSortId(Long.parseLong((String) baseInfo.get("showNum")));
        department.setEnabled(true);
        OrganizationMessage result = orgManagerDirect.addDepartment(department);
        System.out.println(result.isSuccess());
        if (!result.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_1_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }

    private void deleteDept(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        /**
         * SYNC_ERR_1_2_0002	组织不存在
         * SYNC_ERR_1_2_0005	存在子组织
         * SYNC_ERR_1_2_0006	组织下存在用户
         * SYNC_ERR_1_2_9999	其它错误
         */
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
//        Long deptId = departmentManager.getDepartmentIdByCode((String) baseInfo.get("deptUniCode"));
        List<V3xOrgDepartment> departments = orgManagerDirect.getAllDepartments(null,null,true,null,null,null);
        Long deptId = -1L;
        V3xOrgDepartment orgDepartment = null;
        for (V3xOrgDepartment department : departments) {
            if (department.getCode().equals((String) baseInfo.get("deptUniCode"))) {
                orgDepartment = department;
                deptId = department.getId();
                break;
            }
        }
//        V3xOrgDepartment orgDepartment = orgManager.getDepartmentById(deptId);
        if (orgDepartment == null) {
            returnMap.put("status", 2);
            returnMap.put("errcode", "SYNC_ERR_1_2_0002");
            returnMap.put("errormsg", "组织不存在");
            return;
        }
        List<V3xOrgDepartment> childs = orgManager.getChildDepartments(deptId, false, true);
        if (!(childs == null || childs.size() <= 0)){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_0005");
            returnMap.put("errormsg","存在子组织");
            return;
        }
        List<V3xOrgMember> members = this.orgManager.getAllMembersByDepartmentId(deptId, true, (Integer)null, (Boolean)null, (Boolean)null, (String)null, (Object)null, (FlipInfo)null);
        boolean isAllMemberUnEnabled = true;
        Iterator var4 = members.iterator();
        while(var4.hasNext()) {
            V3xOrgMember mem = (V3xOrgMember)var4.next();
            if (mem.isValid()) {
                isAllMemberUnEnabled = false;
                break;
            }
        }
        if (!ListUtils.EMPTY_LIST.equals(members) && !isAllMemberUnEnabled){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_2_0006");
            returnMap.put("errormsg","组织下存在用户");
            return;
        }
        OrganizationMessage result = new OrganizationMessage();
        if (!orgDepartment.getIsDeleted())
            result = orgManagerDirect.deleteDepartment(orgDepartment);
        else {
            returnMap.put("status", 2);
            returnMap.put("errcode", "SYNC_ERR_1_2_9999");
            returnMap.put("errormsg", "其它错误");
        }
        if (!result.isSuccess()) {
            returnMap.put("status", 2);
            returnMap.put("errcode", "SYNC_ERR_1_2_9999");
            returnMap.put("errormsg", "其它错误");
        } else {
            returnMap.put("status", 1);
            returnMap.put("errcode", "");
            returnMap.put("errormsg", "");
        }
    }
    private void updateDept(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> parentInfo = (Map<String, Object>) newContent.get("parentInfo");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        if (StringUtils.isEmpty(baseInfo.get("deptName"))|| StringUtils.isEmpty(baseInfo.get("deptUniCode"))
                || StringUtils.isEmpty(baseInfo.get("showNum"))||StringUtils.isEmpty(parentInfo.get("parentCode"))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_4_0003");
            returnMap.put("errormsg","必填属性未填");
            return;
        }
        List<V3xOrgDepartment> departments = orgManagerDirect.getAllDepartments(null,null,true,null,null,null);
        Long deptId = -1L;
        V3xOrgDepartment orgDepartment = null;
        for (V3xOrgDepartment department : departments) {
            if (department.getCode().equals((String) baseInfo.get("deptUniCode"))) {
                deptId = department.getId();
                orgDepartment = department;
                break;
            }
        }
//        Long deptId = departmentManager.getDepartmentIdByCode((String) baseInfo.get("deptUniCode"));
//        V3xOrgDepartment orgDepartment = orgManager.getDepartmentById(deptId);
        if (orgDepartment == null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_4_0002");
            returnMap.put("errormsg","组织不存在");
            return;
        }
        if (parentInfo.get("isCorp").equals("0")){
            Long departmentId = -1L;
            for (V3xOrgDepartment department : departments) {
                if (department.getCode().equals((String) parentInfo.get("parentCode"))) {
                    departmentId = department.getId();
                    break;
                }
            }
//            Long departmentId = departmentManager.getDepartmentIdByCode((String) parentInfo.get("parentCode"));
            if (StringUtils.isEmpty(departmentId)||departmentId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_1_4_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            orgDepartment.setSuperior(departmentId);
            V3xOrgUnit unit = orgManager.getUnitById(departmentId);
            orgDepartment.setOrgAccountId(unit.getOrgAccountId());
        } else if (parentInfo.get("isCorp").equals("1")){
            Long accountId = accountManager.getAccountIdByCode((String) parentInfo.get("parentCode"));
            if (StringUtils.isEmpty(accountId)||accountId.equals(-1L)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_1_4_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            orgDepartment.setSuperior(accountId);
            orgDepartment.setOrgAccountId(accountId);
        }
        orgDepartment.setName((String) baseInfo.get("deptName"));
        orgDepartment.setSortId(Long.parseLong((String) baseInfo.get("showNum")));
        OrganizationMessage result = orgManagerDirect.updateDepartment(orgDepartment);
        System.out.println(result.isSuccess());
        if (!result.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_1_4_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }

    private void addMember(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException, ParseException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> parentInfo = (Map<String, Object>) newContent.get("parentInfo");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        V3xOrgMember orgMember = orgManager.getMemberByLoginName((String) baseInfo.get("loginName"));
        if (orgMember != null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_1_0001");
            returnMap.put("errormsg","用户已存在");
            return;
        }
        if (StringUtils.isEmpty(baseInfo.get("userName"))|| StringUtils.isEmpty(baseInfo.get("loginName"))|| StringUtils.isEmpty(parentInfo.get("parentCode"))
                || StringUtils.isEmpty(parentInfo.get("showNum"))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_1_0003");
            returnMap.put("errormsg","必填属性未填");
            return;
        }
        Long accountId = null;
        Long departmentId = null;
        if (parentInfo.get("isCorp").equals("0")){   //父级是部门
            String departmentCode = (String) parentInfo.get("parentCode");  //部门编码
            List<V3xOrgDepartment> departments = orgManagerDirect.getAllDepartments(null,null,true,null,null,null);
            V3xOrgDepartment orgDepartment = null;
            for (V3xOrgDepartment department : departments) {
                if (department.getCode().equals(departmentCode)) {
                    departmentId = department.getId();
                    orgDepartment = department;
                    break;
                }
            }
//            departmentId = departmentManager.getDepartmentIdByCode(departmentCode);
//            V3xOrgDepartment orgDepartment = orgManager.getDepartmentById(departmentId);
            if (orgDepartment == null){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_2_1_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            accountId = orgDepartment.getOrgAccountId();
        }else if (parentInfo.get("isCorp").equals("1")){   //父级是公司
            String accountCode = (String) parentInfo.get("parentCode");  //公司编码
            accountId = accountManager.getAccountIdByCode(accountCode);
            if (StringUtils.isEmpty(accountId)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_2_1_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
        }
        System.out.println("accountId:"+accountId+",departmentId:"+departmentId);
//        if (StringUtils.isEmpty(accountId)|| StringUtils.isEmpty(departmentId)||accountId.equals(-1L)||departmentId.equals(-1L)){
//            returnMap.put("status",2);
//            returnMap.put("errcode","SYNC_ERR_2_1_0004");
//            returnMap.put("errormsg","找不到父级");
//            return;
//        }
        V3xOrgMember member = new V3xOrgMember();
        member.setIdIfNew();
        member.setName((String) baseInfo.get("userName"));
        member.setProperty("birthday",Datetimes.parse(String.valueOf(baseInfo.get("birthday")), TimeZone.getDefault(), "yyyy-MM-dd"));
        member.setProperty("idnum",(String)baseInfo.get("idCardNumber"));
        if (baseInfo.get("gender") != null) {
            Integer gender = baseInfo.get("gender").equals("Z02") ? 2 : baseInfo.get("gender").equals("Z01") ? 1 : -1;
            member.setProperty("gender",gender);
        }
        member.setProperty("telnumber",(String)baseInfo.get("mobile"));
        member.setProperty("officenumber",(String)baseInfo.get("telephone"));
        member.setProperty("emailaddress",(String)baseInfo.get("email"));
        member.setSortId(Long.parseLong((String) parentInfo.get("showNum")));
        V3xOrgPrincipal v3xOrgPrincipal = member.getV3xOrgPrincipal();
        v3xOrgPrincipal.setLoginName((String) baseInfo.get("loginName"));
        v3xOrgPrincipal.setPassword("123456");
        member.setV3xOrgPrincipal(v3xOrgPrincipal);
        member.setOrgAccountId(accountId);
        member.setOrgDepartmentId(departmentId);
        List<V3xOrgPost> orgPosts = orgManagerDirect.getAllPosts(accountId,true);
        List<V3xOrgLevel> orgLevels = orgManagerDirect.getAllLevels(accountId,true);
        for (V3xOrgPost orgPost : orgPosts) {
            if (orgPost.getName().contains("一般员工"))
                member.setOrgPostId(orgPost.getId());
        }
        for (V3xOrgLevel orgLevel : orgLevels) {
            if (orgLevel.getName().contains("普通员工"))
                member.setOrgLevelId(orgLevel.getId());
        }
//        member.setOrgPostId();  //一般员工
//        member.setOrgLevelId();  //普通员工
        member.setEnabled(true);
        member.setLoginName(member,(String) baseInfo.get("loginName"));
        Integer secLevel = 1;
        if (baseInfo.get("secLevel").equals("0"))
            secLevel = 5;
        else if (baseInfo.get("secLevel").equals("1"))
            secLevel = 2;
        else if (baseInfo.get("secLevel").equals("2"))
            secLevel = 3;
        member.setSecretLevel(secLevel);
        OrganizationMessage organizationMessage= orgManagerDirect.addMember(member);
        System.out.println(organizationMessage.isSuccess());
        if (!organizationMessage.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_1_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }

    private void deleteMember(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        V3xOrgMember member = orgManager.getMemberByLoginName((String) baseInfo.get("loginName"));
        if (member == null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_2_0002");
            returnMap.put("errormsg","用户不存在");
            return;
        }
        OrganizationMessage organizationMessage= orgManagerDirect.deleteMember(member);
        System.out.println(organizationMessage.isSuccess());
        if (!organizationMessage.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_2_9999");
            returnMap.put("errormsg","其它错误");
        }else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }

    private void updateMember(Map<String, Object> map,Map<String,Object> returnMap) throws BusinessException {
        Map<String,Object> syncContent = (Map<String, Object>) map.get("syncContent");
        Map<String,Object> newContent = (Map<String, Object>) syncContent.get("newContent");
        Map<String,Object> parentInfo = (Map<String, Object>) newContent.get("parentInfo");
        Map<String,Object> baseInfo = (Map<String, Object>) newContent.get("baseInfo");
        V3xOrgMember member = orgManager.getMemberByLoginName((String) baseInfo.get("loginName"));
        if (member == null){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_4_0002");
            returnMap.put("errormsg","用户不存在");
            return;
        }
        if (StringUtils.isEmpty(baseInfo.get("userName"))|| StringUtils.isEmpty(baseInfo.get("loginName"))|| StringUtils.isEmpty(parentInfo.get("parentCode"))
                || StringUtils.isEmpty(parentInfo.get("showNum"))){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_4_0003");
            returnMap.put("errormsg","必填属性未填");
            return;
        }
        Long accountId = null;
        Long departmentId = null;
        if (parentInfo.get("isCorp").equals("0")){   //父级是部门
            String departmentCode = (String) parentInfo.get("parentCode");  //部门编码
            List<V3xOrgDepartment> departments = orgManagerDirect.getAllDepartments(null,null,true,null,null,null);
            V3xOrgDepartment orgDepartment = null;
            for (V3xOrgDepartment department : departments) {
                if (department.getCode().equals(departmentCode)) {
                    departmentId = department.getId();
                    orgDepartment = department;
                    break;
                }
            }
//            departmentId = departmentManager.getDepartmentIdByCode(departmentCode);
//            V3xOrgDepartment orgDepartment = orgManager.getDepartmentById(departmentId);
            if (orgDepartment == null) {
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_2_4_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
            accountId = orgDepartment.getOrgAccountId();
        }else if (parentInfo.get("isCorp").equals("1")){   //父级是公司
            String accountCode = (String) parentInfo.get("parentCode");  //公司编码
            accountId = accountManager.getAccountIdByCode(accountCode);
            if (StringUtils.isEmpty(accountId)){
                returnMap.put("status",2);
                returnMap.put("errcode","SYNC_ERR_2_4_0004");
                returnMap.put("errormsg","找不到父级");
                return;
            }
        }
        System.out.println("accountId:"+accountId+",departmentId:"+departmentId);
//        if (StringUtils.isEmpty(accountId)|| StringUtils.isEmpty(departmentId)||accountId.equals(-1L)||departmentId.equals(-1L)){
//            returnMap.put("status",2);
//            returnMap.put("errcode","SYNC_ERR_2_4_0004");
//            returnMap.put("errormsg","找不到父级");
//            return;
//        }
        member.setName((String) baseInfo.get("userName"));
        member.setProperty("birthday",Datetimes.parse(String.valueOf(baseInfo.get("birthday")), TimeZone.getDefault(), "yyyy-MM-dd"));
        member.setProperty("idnum",(String)baseInfo.get("idCardNumber"));
//        Integer gender = baseInfo.get("gender").equals("Z02") ? 2 : baseInfo.get("gender").equals("Z01") ? 1 : -1;
//        member.setProperty("gender",gender);
        if (baseInfo.get("gender") != null) {
            Integer gender = baseInfo.get("gender").equals("Z02") ? 2 : baseInfo.get("gender").equals("Z01") ? 1 : -1;
            member.setProperty("gender",gender);
        }
        member.setProperty("telnumber",(String)baseInfo.get("mobile"));
        member.setSortId(Long.parseLong((String) parentInfo.get("showNum")));
        member.setProperty("officenumber",(String)baseInfo.get("telephone"));
        member.setProperty("emailaddress",(String)baseInfo.get("email"));
//        V3xOrgPrincipal v3xOrgPrincipal = member.getV3xOrgPrincipal();
//        v3xOrgPrincipal.setLoginName((String) baseInfo.get("loginName"));
//        v3xOrgPrincipal.setPassword("123456");
//        member.setV3xOrgPrincipal(v3xOrgPrincipal);
        Integer secLevel = 1;
        if (baseInfo.get("secLevel").equals("0"))
            secLevel = 5;
        else if (baseInfo.get("secLevel").equals("1"))
            secLevel = 2;
        else if (baseInfo.get("secLevel").equals("2"))
            secLevel = 3;
        member.setSecretLevel(secLevel);
        member.setOrgAccountId(accountId);
        member.setOrgDepartmentId(departmentId);
        member.setLoginName(member,(String) baseInfo.get("loginName"));
        member.setEnabled(true);
        OrganizationMessage organizationMessage= orgManagerDirect.updateMember(member);
        System.out.println(organizationMessage.isSuccess());
        if (!organizationMessage.isSuccess()){
            returnMap.put("status",2);
            returnMap.put("errcode","SYNC_ERR_2_4_9999");
            returnMap.put("errormsg","其它错误");
        } else {
            returnMap.put("status",1);
            returnMap.put("errcode","");
            returnMap.put("errormsg","");
        }
    }

}