package com.seeyon.ctp.portal.sso;

import com.eetrust.security.plugin.MessageConstants;
import com.eetrust.security.plugin.SIDPlugin;
import com.seeyon.ctp.common.SystemEnvironment;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.util.StringUtils;
import java.util.Date;

import java.io.*;
import java.util.Properties;

public class MySSOLoginHandshake extends SSOLoginHandshakeAbstract {
    private static final Log log = LogFactory.getLog(MySSOLoginHandshake.class);
    // “ticket” 就是ticket取得的参数值
    public String handshake(String ticket) {
        Date date1 = new Date();
        log.info("--------------------------开始时间-----------"+date1);
        if (StringUtils.isEmpty(ticket))
        {
            log.error( "单点登录缺少登录票据[ticket]信息!");
            return null;
        }
        // 认证服务器地址
        String authServerIp = "";

        // 认证服务器端口
        String authServerPort = "";
        // 认证服务器地址1
        String authServerIp1 = "";

        // 认证服务器端口1
        String authServerPort1 = "";

        // 业务系统编码
        String authAppCode = "";

        String filePath = SystemEnvironment.getApplicationFolder() + File.separator + "fkmap" + File.separator + "url.properties" ;
        InputStream in = null;
        try {
            in = new BufferedInputStream(new FileInputStream(filePath));
            Properties p = new Properties();
            p.load(in);
            authServerIp = p.getProperty("authServerIp");
            authServerPort = p.getProperty("authServerPort");
            authServerIp1 = p.getProperty("authServerIp1");
            authServerPort1 = p.getProperty("authServerPort1");
            authAppCode = p.getProperty("authAppCode");
        } catch (Exception e) {
            e.printStackTrace();
        }finally {
            if (in != null) {
                try {
                    in.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

        SIDPlugin sid = new SIDPlugin(authServerIp, Integer.parseInt(authServerPort));
        int result = sid.Security_VerifyTicket(authAppCode, ticket);
//        log.info("ticket:"+ticket);
        if (result == MessageConstants.SECURITY_SERVICE_SUCCESS)
        {
            // 票据验证成功, 获取用户唯一标识
            String passport = sid.getPassport();
            log.info("系统获取到的ticket:"+ticket);
            log.info("单点登录成功! 用户唯一标识: " + passport);
            Date date2 = new Date();
            log.info("--------------------------结束时间-----------"+date2);
            long time = date1.getTime() - date2.getTime() > 0 ? date1.getTime()
                    - date2.getTime() : date2.getTime() - date1.getTime();
            log.info("--------------------------差时间-----------"+time);
            return passport;
        }
        else
        {
            // 认证失败, 获取错误编码
            String errorCode = sid.getErrorCode();
            if (errorCode.equals("ERROR_CODE_AUTH_REQUEST_EXPIRED")) {
                SIDPlugin sid1 = new SIDPlugin(authServerIp1, Integer.parseInt(authServerPort1));
                int result1 = sid1.Security_VerifyTicket(authAppCode, ticket);
                if (result1 == MessageConstants.SECURITY_SERVICE_SUCCESS) {
                    // 票据验证成功, 获取用户唯一标识
                    String passport1 = sid1.getPassport();
                    log.info("系统获取到的ticket:" + ticket);
                    log.info("单点登录成功! 用户唯一标识: " + passport1);
                    Date date2 = new Date();
                    log.info("--------------------------结束时间-----------"+date2);
                    long time = date1.getTime() - date2.getTime() > 0 ? date1.getTime()
                            - date2.getTime() : date2.getTime() - date1.getTime();
                    log.info("--------------------------差时间-----------"+time);
                    return passport1;
                } else {
                    String errorCode1 = sid1.getErrorCode();
                    // 认证失败, 获取错误编码
                    String errorMsg1 = sid1.getErrorMsg();
                    log.error("单点登录失败! 错误编码: " + errorCode1 + ", 错误信息: " + errorMsg1);
                    return null;
                }
            }
            // 认证失败, 获取错误信息
            String errorMsg = sid.getErrorMsg();
            log.error( "单点登录失败! 错误编码: " + errorCode + ", 错误信息: " + errorMsg);
            return null;
        }
    }
    public void logoutNotify(String ticket) {
        log.info("退出登录："+ticket);
    }

}